// Black Magic. The editor that brings you Dark Prophecy.
// 
// All new all powerful Zelda 3 editing machine!!!
// Author MathOnNapkins, Copyright 2005, 2006

    //includes

    // 1. #include "Black Magic.h"
    #include <windows.h>
    #include "Limits.h"
    #include <direct.h>

    /**#include "Strings.h"*/
    #include "Black Magic.h"
    #include "Core.h"
    /**#include "Objects.h"*/
    #include "DungMode.h"
    #include "OverMode.h"
    #include "OverModeGui.h"
    #include "Music.h"
    #include "PathName.h"

    #include <stack>

// ===============================================================

    int do_nothing(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
    {
        switch(msg)
        {
        case BM_TEARDOWN:

            return 1;

            break;
        }

        return 0;
    }

// ===============================================================

    int APIENTRY WinMain(HINSTANCE hInstance,
                         HINSTANCE hPrevInstance,
                         LPSTR     lpCmdLine,
                         int       nCmdShow)
    {
        // deprecated
        ZeroMemory(windowList, sizeof(windowList));
        
        if(!GetFile(&bmOFN, NULL))
            return 0;
        
	    return 0;
    }

// ===============================================================

    long _stdcall MainProc(HWND mainHwnd, UINT mainMsg, WPARAM mainWparam, LPARAM mainLparam)    
    {
        // handles the main window, which will load Zelda 3 files for editing.
        // ------------------------------------

            case IDC_LOADROM:
                
                GetFile(&bmOFN, mainHwnd);      
                
                break;

            case IDC_ROMINFO:
            
                rom = game->image;
                
                for( index ; index < 0x200000; index++ )
                {
                    sum += GetByte(rom, index);
                    
                    if( rom->error == 1)
                    {
                        rom->error = 0;
                        break;                    
                    }
                }
                
                sum &= 0xFFFF;
                
                wsprintf(msgBuffer, "%X", sum);
                
                MessageBox(mainHwnd, msgBuffer, "checksum", MB_OK);
                
                break;
                
            case IM_DUNGEONS:

                ImportDungeons(game, thisProg);

                break;

            case EX_DUNGEONS:

                ExportDungeons(game, thisProg);

                break;

            case IM_OVERWORLD:
   
                ImportOverworld(game, thisProg);

                break;

            case EX_OVERWORLD:

                ExportOverworld(game, thisProg);

                break;

            case IDC_EXPORT_TEXT:

                DumpScript(game, thisProg);

                break;

            case IDC_EXPORT_MUSIC:

                ExportSpc(game);

                break;

            case IDC_IMPORT_TEXT:

                InsertScript(game, thisProg);

                break;

            case IDC_QUIT:
      
    quitting:

                SendMessage(mainHwnd, BM_TEARDOWN, 0, 0);

                if(SaveGame(mainHwnd) == IDCANCEL)
                {
                    // If the game is a valid file, "cancel"
                    // should do nothing.
                    if(game->image->length != 0)
                        return 0;
                }

                // Otherwise, delete this game structure off of the list.
                DeletePointer();
                //DestroyWindow(mainHwnd);
                game = 0;

                if(numGames == 0)
                    exit(0);

                goto def_proc;
                
                break;
        
            default:

                // run a handler that checks which editing mode we're in and
                // updates the screen accordingly. Might take a bit of machinery
                // to get working, but it will be worth it.
            
                // BM_COMMAND( );

                goto bm_default;

                break;
            }

            break;

    bm_default:

        default:
        
            if(!game)
                break;
            else
                game->currentFunc(mainHwnd, mainMsg, mainWparam, mainLparam);

            break;

        }

    def_proc:

        return DefWindowProc(mainHwnd, mainMsg, mainWparam, mainLparam);
    }

// ===============================================================

    // imported from SNESDisasm.cpp
    // opens a file dialog and retrieves an openfilename structure.
    // look out for a bug in WindowsNT 4.0 and the lStructSize of *ofn.

    int GetFile(OPENFILENAME *ofn, HWND win)
    {
        char tempFileName[MAX_PATH];
        
        uint32_t fLength = 0; 
        uint32_t i       = 0; // nothing but a work variable
        
        unsigned long dummyRead = 0; // Tells us how many bytes are read.
        
        HANDLE fHandle = 0;
        
        // ----------------------------------
            
            // Note if the game had a header, I think the file pointer is already at 0x200
            // from the previous read.
            
            if(fLength > 0x100000)
            {
                Check_BM_Header(newGamePtr);
                
                newGamePtr->numRooms = 320;
                newGamePtr->numEntrances = 0x85;
            }
            else
            {
                int newLength = 0x200000;
                
                // Expands the Rom to 2 megabytes.
                ExpandRom(&newLength, 1);
                    
                Create_BM_Header(newGamePtr);
                
                newGamePtr->numRooms = 320;
                newGamePtr->numEntrances = 0x85;
            }

            // Decompress all the graphics out of the rom so they're available at run time.
            newGamePtr->LoadAllGfx();

            newGamePtr->currentWES.numElements = 0;
            newGamePtr->currentWES.WESet = 0;

            newGamePtr->currentFile = &( newGamePtr->dungeonFile );

            LoadDungeonFile(newGamePtr, newGamePtr->currentFile);
            LoadDialogueFile(newGamePtr);

            for(i = 0; i < 2; ++i)
                newGamePtr->BG_Map[i] = CreateBuffer(0x2000);

            newGamePtr->cgram   = CreateBuffer(0x200);
            newGamePtr->aniVram = CreateBuffer(0x3000);
            newGamePtr->vram    = CreateBuffer(0x10000);

            newGamePtr->gi = (giPtr) malloc(sizeof(graphicsInfo));

            // Add code to ask user if they would care to pad out the game to make
            // it work. Perhaps also check to look for signs of Hyrule Magic's influence.

            CloseHandle(newGamePtr->zgFileHandle);

            SetWindowLong(newGamePtr->subWindow, 4, 1);
	    }	

	    return 1;
    }

// ===============================================================

    int SaveGame(HWND win)
    {
        int result;

        zgPtr game = (zgPtr) GetWindowLong(win, 0);

        // -------------------------------------------

        //if(FindGame(win) == -1)
        /*{
            // Means the data for the game file wasn't found in our list.
            // This is a bad error that should never happen theoretically.
            MessageBox(win, "Data Not Found!", "bad error", MB_OK);
        
            return IDCANCEL;
        }*/

        result = MessageBox(win, "Save Game?", "Black Magic Save", MB_YESNOCANCEL|MB_ICONWARNING);

        switch(result)
        {
        case IDCANCEL:

            return result;

            break;

        case IDYES:

            SaveDataToFile(game);

            return result;

            break;

        case IDNO:

            return result;

            break;

        default:

            break;
        }

        return IDCANCEL;
    }

// ===============================================================

    // When the user closes a window, we have to free up room in our game list.
    // We'll compact it down too to avoid bloating.

    void DeletePointer()
    {    
        int counter = zgIndex;

        // zgIndex is used as a global index to the game we need to be working on at the moment.    

        zgPtr game = (zgPtr) GetWindowLong(windowList[zgIndex], 0);

        if(game->image->length != 0)
        {
            DeallocBuffer(game->cgram);
            DeallocBuffer(game->aniVram);
            DeallocBuffer(game->vram);
        }
    
        DeallocBuffer(game->BG_Map[0]);
        DeallocBuffer(game->BG_Map[1]);

        DestroyBuffer(game->romName);
        DestroyBuffer(game->image);
    
        if(game->hasHeader)
            DestroyBuffer(game->headerBuf);

        if(zgIndex == (numGames - 1) )
        {
            // Handles the game being the last in the list.
            // Handles the case where there's only one game. In that case
            windowList[zgIndex] = 0;
        }
        else 
        {
            // Handles the rest by compacting the window List down.
            for(counter; counter < numGames - 1; counter++)
            {
                windowList[counter] = windowList[counter + 1];
                windowList[counter + 1] = NULL;
                game = (zgPtr) GetWindowLong(windowList[counter], 0);
                game->index--;
            }
        }

        numGames--;
    }

// ===============================================================

    int SaveDataToFile(zgPtr game)
    {
        char commandLine[0x400] = "";

        unsigned long numBytesWritten;

        PathName *p = NULL;

        STARTUPINFO sInfo;
        PROCESS_INFORMATION pi;

        // ------------------------------
    
        game->zgFileHandle = CreateFile((char*) game->romName->contents,
                                        GENERIC_WRITE,
                                        0,
                                        0,
                                        OPEN_ALWAYS,
                                        0,
                                        0);

        if( !(game->zgFileHandle) )
            return 0;

        SaveExtendedDataToFile(game);    

        if(game->hasHeader)
            WriteFile(game->zgFileHandle,
                      game->headerBuf->contents,
                      game->headerBuf->length,
                      &numBytesWritten,
                      0);


        WriteFile(game->zgFileHandle,
                  game->image->contents,
                  game->image->length,
                  &numBytesWritten,
                  0);

        SetEndOfFile(game->zgFileHandle);

        CloseHandle(game->zgFileHandle);
    
        memset(&sInfo, 0, sizeof(sInfo));
        memset(&pi,    0, sizeof(pi));

        sInfo.cb = sizeof(sInfo); 

        p = new PathName( (const char*) ToString(game->romName) );

        chdir( (const char*) p->GetDirectory() );

        delete p;

        sprintf(commandLine, "xkas.exe \".\\hooks.asm\" \"%s\"", (const char*) ToString(game->romName));

        if(CreateProcess(NULL, commandLine, NULL, NULL, FALSE, 0, NULL, NULL, &sInfo, &pi))
        {
            WaitForSingleObject(pi.hProcess, 10000);
        }
        else
        {
            int i = GetLastError();
        }

        // ------------------------------


        return 1;
    }

// ===============================================================

    void SaveExtendedDataToFile(zgPtr game)
    {
        // This organizes all the extended data that is written past the end
        // of the normal sized rom. This has to be done carefully so that
        // 1. no data crosses a bank boundary without being accounted for
        // 2. no RATS tags are overwritten (implement later)

        DungeonFile* dngFile = game->currentFile;
        Buffer temp1;
        bufPtr temp2;

        uint32_t offset1 = 0;
        uint32_t offset2 = 0;
        uint32_t offset3 = 0;
        uint32_t offset4 = 0;
    
        uint32_t index1 = 0;
        uint32_t index2 = 0;

        // --------------------------------------------

        // Output hooks.asm and rom-specific configurations.
        SetupAsmPatching(game);

        // Write the headers and update each pointer in the table
  
        temp2 = 0;

        offset1 = Get3Bytes(game->image, bm_header_loc);

        // start writing data right after where the bm_header will go
        // represents the start of where the new header data will go
        //offset2 = offset1 + sizeof(game->bm_Header);

        offset2 = 0x8000 + offset1 + sizeof(game->bm_Header);
   
   
        // represents the rom address of the beginnning of the header pointer table
        offset4 = CpuToRomAddr(game->bm_Header.dngHeaderOffset);

        game->bm_Header.dngHeaderBank = GetBank(RomToCpuAddr(offset2));
        PutByte(game->image, asm_header_bank, game->bm_Header.dngHeaderBank);
       
        // I put the headers somewhere I know will not overlap a bank. And the data is
        // small enough to fit in one bank anyway (1/16th the size roughly)
        for( index1 = index2 = 0; index1 < 320; index1++)
        {
            offset3 = (RomToCpuAddr(offset2) & 0xFFFF);
            Put2Bytes(game->image, offset4, offset3); offset4 += 2;
            CopyBufferWB(game->image, &dngFile->headerData, &offset2, &index2, 14);
        }

        // Now write in the object data
        index1 = 0;
        index2 = 0;
        offset3 = 0;
        offset4 = 0;
        temp2 = 0;

        // Retrieves the in-rom location of the dungeon obj pointer table
        offset4 = CpuToRomAddr(game->bm_Header.dngObjOffset);    
    
        for( index1 = 0; index1 < 320; index1++)
        {
            offset3 = RomToCpuAddr(offset2);
            temp2 = &(dngFile->objectData[index1]);
            index2 = 0;

            // Determine if a bank boundary would be crossed
            if( IsBankChange(offset3, temp2->length) )
            {
                // move into the next (program) bank
                offset3 = ((GetBank(offset3) + 1) << 0x10) | 0x8000;
                offset2 = CpuToRomAddr(offset3);
            }

            Put3Bytes(game->image, offset4, offset3); offset4 += 3;
            CopyBuffer(game->image, temp2, offset2, 0, temp2->length);

            offset2 += temp2->length;
        }

        // Write in the entrance Data

        // This is easy :)
        CopyBuffer(game->image, 
                   &dngFile->entrances.entranceBuffer,
                   game->bm_Header.dngEntranceOffset,
                   0,
                   dngFile->entrances.entranceBuffer.length);
   
        // Write in the chest data

        // The size of the Buffer
        index2 = dngFile->chestLocationData.length;
        offset3 = RomToCpuAddr(offset2);
        game->bm_Header.dngChestOffset = offset3;        
        temp2 = &(dngFile->chestLocationData);
    
        if( IsBankChange(offset3, index2) )
        {
            // move into the next (program) bank
            offset3 = ((GetBank(offset3) + 1) << 0x10) | 0x8000;
            offset2 = CpuToRomAddr(offset3);
        }

        Put2Bytes(game->image, asm_num_chests, index2);
        Put3Bytes(game->image, asm_chest_ref, offset3);

        index1 = 0;

        CopyBufferWB(game->image, temp2, &offset2, &index1, index2);
    
        // Saves dungeon sprite data to the file
        SaveSprites(game, &offset2);

        // Saves the main dialogue information to the file
        SaveText(game, &offset2);

        // Save Overworld Data
        SaveOverworldData(game, &offset2);

        // Compress any graphics that have been modified (via importing)
        game->SaveGraphics(&offset2);
        
        // Finally, write the updated BH_Header to file
        temp1.contents = (unsigned char*) &(game->bm_Header);
        temp1.length = sizeof(game->bm_Header);
        CopyBuffer(game->image, &temp1, offset1, 0, temp1.length);
        
        // All done

    }

// ===============================================================

    bool SaveText(zgPtr game, uint32_t *romOffset)
    {
        uint32_t b                = 0;
        uint32_t textLen          = 0;
        uint32_t pointerCpu       = 0;
        uint32_t pointerRom       = *romOffset;
        uint32_t dataCpu          = 0;
        uint32_t dataRom          = 0;
        uint32_t pointerTableSize = 0;
        uint32_t dummy            = 0;

        bufPtr text = NULL;

        // -----------------------------------

        (*romOffset) = RomToCpuAddr(*romOffset);

        // calculate the pointer table size (each is 3 bytes)
        pointerTableSize = game->dialogueFile.numMsgs * 3;

        pointerCpu = AdvancePointer(game, romOffset, pointerTableSize);
        pointerRom = CpuToRomAddr(pointerCpu);

        game->bm_Header.textOffset  = pointerCpu;
        game->bm_Header.textNumMsgs = game->dialogueFile.numMsgs;

        // perform a small mod to the asm of the game (changes a 2 3-byte pointers)
        Put3Bytes(game->image, asm_text_ref,  pointerCpu);
        Put3Bytes(game->image, asm_text_ref2, pointerCpu + 2);

        for(b = 0; b < game->dialogueFile.numMsgs; b++, pointerRom += 3)
        {
            text    = game->dialogueFile.data[b];
            textLen = text->length;
            dummy   = 0;

            dataCpu = AdvancePointer(game, romOffset, textLen);
            dataRom = CpuToRomAddr(dataCpu);

            // store the CPU address to the data in the pointer table
            Put3Bytes(game->image, pointerRom, dataCpu);

            // Copy the text data to its location in the rom
            CopyBuffer(game->image, text, dataRom, 0, text->length);        
        }

        *romOffset = dataRom;

        return true;
    }


// ===============================================================

    // Write in the Sprite data
    
    bool SaveSprites(zgPtr game, uint32_t *romOffset)
    {

        unsigned char sprite_hook_routine[] = { _SEP(0x30),
                                                _PEA(0xC1,0x72),
                                                _REP(0x30),
                                                _LDAA(0x04,0x8E),
                                                _TAX,
                                                _ASLA,
                                                _TAY,
                                                _SEP(0x20),
                                                _LDALX(0xFF,0xFF,0xFF),
                                                _PHA,
                                                _PLB,
                                                _REP(0x30),
                                                _TXA,
                                                _ASLA,
                                                _TAX,
                                                _LDALX(0x09, 0xD6, 0x2E),
                                                _JML(0x09,0xC2,0x9A),
                                                '\0'};

        const uint32_t bankTableSize = 0x140;
        uint32_t a = 0;
        uint32_t routineCpu = 0;
        uint32_t routineRom = *romOffset;
        uint32_t pointerCpu = 0;
        uint32_t pointerRom = 0;
        uint32_t dataCpu = 0;
        uint32_t dataRom = 0;
        uint32_t dummy = 0;

        Buffer temp1;
        bufPtr temp2;

        temp1.contents = sprite_hook_routine;
        temp1.length = strlen((char*) sprite_hook_routine);
 
        routineCpu = RomToCpuAddr(routineRom);

        if( IsBankChange(routineCpu, temp1.length) )
        {
            // move into the next (program) bank
            routineCpu = ((GetBank(routineCpu) + 1) << 0x10) | 0x8000;
            routineRom = CpuToRomAddr(routineCpu);
        }

        // This hooks the routine that calls the sprite loading function
        // (at 0x4C16E) and jumps it into extended data where we do some setup
        // of the data to change the data bank register
        PutByte(game->image, asm_sprite_hook, 0x5C);
        Put3Bytes(game->image, asm_sprite_hook + 1, routineCpu);

        pointerRom = routineRom + temp1.length;
        pointerCpu = RomToCpuAddr(pointerRom);

        if( IsBankChange(pointerCpu, bankTableSize) )
        {
            pointerCpu = ((GetBank(pointerCpu) + 1) << 0x10) | 0x8000;
            pointerRom = CpuToRomAddr(pointerCpu);
        }

        // this is the start of the banks table (each room has an associated bank
        // because the sprite data could be in more than one bank.)
        game->bm_Header.dngSpriteBanks = pointerRom;

        dataRom = pointerRom + bankTableSize;
        dataCpu = RomToCpuAddr(dataRom);

        game->bm_Header.dngSpriteOffset = pointerRom + bankTableSize;

        // This stores the address of the bank table into the routine
        Put3Bytes(&temp1, 
                  0x10, 
                  pointerCpu);

        // stores the routine itself to ROM
        CopyBufferWB(game->image, &temp1, &routineRom, &dummy, temp1.length);
       
        for(a = 0; a < 0x140 ; a++)
        {
            temp2 = &(game->currentFile->spriteData[a]);
            dataCpu = RomToCpuAddr(dataRom);

            if( IsBankChange(dataCpu, temp2->length) )
            {
                dataCpu = ( (GetBank(dataCpu) + 1 ) << 0x10 ) | 0x8000;
                dataRom = CpuToRomAddr(dataCpu);
            }

            // Store the bank entry
            PutByte(game->image,
                    game->bm_Header.dngSpriteBanks + a,
                    GetBank(dataCpu));
        
            // Store the pointer's absolute portion
            Put2Bytes(game->image,
                      asm_sprite_local + (a*2),
                      dataCpu);

            dummy = 0;

            CopyBufferWB(game->image,
                         temp2,
                         &dataRom,
                         &dummy,
                         temp2->length);
        }

        *romOffset = dataRom;

        return true;
    }

// ===============================================================

    char* GetAsmTextResource(int resourceID)
    { 
        char *textBuf      = NULL;

        uint32_t textSize       = 0;

        HRSRC textRsrc     = NULL;
    
        HGLOBAL textHandle = NULL;

        // -----------------------------------------

        // output the embedded file hooks.asm
        textRsrc   = FindResource(thisProg, MAKEINTRESOURCE(resourceID), "TEXT");

        if(!textRsrc) return NULL;

        textSize   = SizeofResource(thisProg, textRsrc);

        if(!textSize) return NULL;

        textHandle = LoadResource(thisProg, textRsrc);

        if(!textHandle) return NULL;

        textBuf    = (char*) LockResource(textHandle);

        return textBuf;
    }

// ===============================================================

    void SetupAsmPatching(zgPtr game)
    {
        char *hooksText = NULL;

        PathName *p = NULL;

        FILE *f = NULL;

        // ------------------------------------

        // output the embedded file hooks.asm
        hooksText = GetAsmTextResource(IDR_HOOKS_ASM);

        if(!hooksText)
        {
            return;
        }

        p = new PathName( (const char*) ToString(game->romName) );

        chdir( (const char*) p->GetDirectory() );

        f = fopen("hooks.asm", "wb");

        if(f)
        {
            // initialize the ASM file with basic information about the ROM and a couple basic macros.
            if(game->hasHeader)
                fprintf(f, "\nheader\n");

            fprintf(f, "%s", hooksText);

            fclose(f);
        }

        delete p;

        return;
    }

// ===============================================================

    BOOL CALLBACK MoveChildren(HWND hwndChild, LPARAM lParam)
    {
        RECT cRect;

        uint32_t scrollDireciton = (int) lParam >> 16;

        GetClientRect(hwndChild, &cRect);
    
        MoveWindow(hwndChild,
                   cRect.left + 20,
                   cRect.top + 20,
                   cRect.right - cRect.left,
                   cRect.bottom - cRect.top,
                   true);

        return 1;
    }

// ===============================================================

    void DrawBitmap(HWND win)
    {
        // apparently deprecated. consider removing (01/2009)

        /*int indic;

        HDC winDC = GetDC(win);
        BITMAP bm;

        SnesImage *testImage = gameList[zgIndex]->testImage;

        if(testImage)
            memcpy(bmInfoPtr->bmiColors, testImage, sizeof(SnesImage));

        mainBM = CreateDIBitmap(winDC, 
                                bmInfoHeadPtr,
                                CBM_INIT,
                                (bmInfoPtr)->bmiColors,
                                (bmInfoPtr),
                                DIB_RGB_COLORS);
    
        HBITMAP oldBM = (HBITMAP) SelectObject(winDC, mainBM);

        indic = GetObject(mainBM, sizeof(BITMAP), &bm);

        //HBITMAP oldBM = (HBITMAP) SelectObject(winDC, mainBM);

        indic = StretchDIBits(winDC,
                          50,
                          50,
                          64,
                          64,
                          0,
                          0,
                          8,
                          8,
                          bmInfoPtr->bmiColors,
                          bmInfoPtr,
                          DIB_RGB_COLORS,
                          SRCCOPY);

        SelectObject(winDC, oldBM);

    end:

        //DeleteDC(bmDC);
        DeleteObject(mainBM);

        */
    }

// ===============================================================

    void ExpandRom(int *argument, int force)
    {
        int newSize = *argument;
        int oldSize = 0;
        int newSizeMegabits = 0;
        int sizeDifference = 0;
        bufPtr gameImage;
    
        zgPtr game = (zgPtr) GetWindowLong(windowList[zgIndex], 0);
    
        newSizeMegabits = newSize / _MEGABIT;
             
        gameImage = game->image;
        oldSize = game->image->length;
                
        if( newSize > oldSize )
        {
            wsprintf(msgBuffer, "Expand ROM to %u Megabits?",newSizeMegabits);

            if(force)
                goto forceExpansion;

            if( MessageBox(0, msgBuffer, "Expand", MB_YESNO) == IDYES)
            {
            forceExpansion:

                sizeDifference = newSize - oldSize;

                if(ResizeBuffer(gameImage, newSize))
                    memset( (gameImage->contents) + oldSize, 0xFF, sizeDifference);

            }
        }
        else if( newSize == oldSize )
        {
            wsprintf(msgBuffer, "ROM is already %u Megabits", newSizeMegabits);

            MessageBox(0, msgBuffer, "Expand", MB_OK);
        }
        else
        {
            wsprintf(msgBuffer, "Shrink ROM to %u Megabits?",newSizeMegabits);

            if( MessageBox(0, msgBuffer, "Expand", MB_YESNO) == IDYES || force)
                ResizeBuffer(game->image, newSize);

                    // RATSSearch( )
                    // Add code here later to make sure critical data isn't being
                    // deleted. Probably use RATS tags to do that.
        }
    
        *argument = game->image->length;
    }

// ===============================================================

    void ChangeWES(WindowElement* we, HWND win, zgPtr game)
    {
        WEStruct *currentWES = &(game->currentWES);

        unsigned int index = 0;

        // Destroy all the old windows and controls.
        for( index = 0; index < currentWES->numElements; index++)
        {  
           DestroyWindow(currentWES->WESet[index].handle);
           currentWES->WESet[index].handle = NULL;               
        }

        currentWES->WESet = 0;
        currentWES->numElements = 0;

        AssignCurrentWES(we);
   
        ActivateCurrentWES(currentWES, win);  
    }

// ===============================================================

    void PopulateCombobox(HWND combobox, char** stringList)
    {
        unsigned int index = 0;

        // The empty string "" is used in my char**'s as a makeshift
        // null terminator.
        while(strcmp(stringList[index], "") != 0)
        {
            SendMessage(combobox,
                        CB_ADDSTRING,
                        0,
                        (LPARAM) stringList[index]);

            index++;
        }

        return;
    }

// ===============================================================
// End of Black Magic.cpp


