    
    #include "constants.h"
    
    /// #include "OverMode.h"
    
    // hvop ppcc cccc cccc (quick map8 guide)
    
    const int charSize             = 1;
    
    // size of a megabit, in terms of bytes.
    const int _MEGABIT             = 0x20000;
    const int _4MEGABITS           = (_MEGABIT * 4);
    const int _MEGABYTE            = (_MEGABIT * 8);
    
    // dungeon asm pointers -------------------------------------
    
    const int asm_header_ref       = 0xB5DD;
    const int asm_header_bank      = 0xB5E7;
    
    const int asm_layout_ref       = 0x882D;
    const int asm_layout_ref2      = 0x8826;
    
    const int asm_object_ref       = 0x874C;
    const int asm_object_ref_2     = 0x8746;
    const int asm_object_ref_3     = 0x8845;
    const int asm_object_ref_4     = 0x883F;
    
    const int asm_entrance_ref     = 0x14813;
    
    const int asm_num_chests       = 0xEBF6;
    const int asm_chest_ref        = 0xEBFB;
    
    const int asm_sprite_ref       = 0x4C298;
    const int asm_sprite_hook      = 0x4C16E;
    
    const int asm_push_block_ref   = 0x15AFA;
    
    // #define asm_sprite_local   0x4CEE7 Shards of Might's location (doesn't work anyway)
    const int asm_sprite_local     = 0x4D62E;
    
    const int asm_text_ref         = 0x744ED; // where the code gets the absolute portion
    const int asm_text_ref2        = 0x744F3; // the code needs this for the bank byte
    const int asm_code_lengths     = 0x7536B; /// should be changed to asm_text_code_lengths?
    
    // overworld asm pointers -------------------------------------
    
    // table of 24-bit pointers to the first half of each overworld map
    // In a clean rom this should be 0x2F94D (0x1794D in rom)
    const int asm_overmap_ptrs     = 0x1759E;
    
    // table of 24-bit pointers to the second half of each overworld map
    // In a clean rom this should be 0x2F5C9 (0x175C9 in rom)
    const int asm_overmap_ptrs2    = 0x175C9;
    
    // if the map16 loader is untouched these should all be 0x038000
    const int asm_map32To16UL      = 0x176AC;
    const int asm_map32To16UR      = 0x176EC;
    const int asm_map32To16LL      = 0x1772C;
    const int asm_map32To16LR      = 0x1776C;
    
    // defaults to $1BB96F ($DB96F in rom)
    const int asm_entrance_ptr_old = 0xDBD1A;
    
    // in a clean rom this is 0xB800 (2 bytes) which references 0x1BB800 (0xDB800) in rom
    const int asm_hole_ptr_old     = 0xDB894;
    
    // graphics asm pointers ---------------------------------------
    
    // ROM addresses of asm location where an untouched Zelda 3 rom will load graphics from
    const int asm_spr_gfx_ptr      = 0x553C;
    const int asm_bg_gfx_ptr       = 0x6790;
    
    const int default_spr_gfx_ptr  = 0xCFF3;
    const int default_bg_gfx_ptr   = 0xCF80;
    
    // black magic specific pointers ------------------------------
    const int expand_info_loc      = 0xFFFFC; 
    
    uint32_t test[]       = { 0x1106, 0x1107, 0x5107, 0x5106, 0x1138, 0x1139, 0x5139, 0x5138 };
    uint32_t bush[]       = { stock_bush };
    uint32_t bush2[]      = { stock_bush2 };
    uint32_t rock_sl[]    = { stock_rock_sl};
    uint32_t rock_sh[]    = { stock_rock_sh };
    uint32_t peg[]        = { stock_peg };
    uint32_t rock_bl[]    = { stock_rock_bl0, stock_rock_bl1, stock_rock_bl2, stock_rock_bl3 };
    uint32_t rock_bh[]    = { stock_rock_bh0, stock_rock_bh1, stock_rock_bh2, stock_rock_bh3 };
    uint32_t warp[]       = { stock_warp };
    uint32_t rockPile[]   = { stock_rockPile0, stock_rockPile1, stock_rockPile2, stock_rockPile3 };
    uint32_t sign[]       = { stock_sign };
    uint32_t grass[]      = { stock_grass };
    uint32_t jumpPoint[]  = { stock_jumpPoint };
    uint32_t burrow[]     = { stock_burrow0, stock_burrow1, stock_burrow2, stock_burrow3 };
    
#if(0)
    
    OverObj over_stock_objs[13] = 
    {
        OverObj(bush,       1, 1, IDC_STOCK_BUSH,      fromMap16),
        OverObj(bush2,      1, 1, IDC_STOCK_BUSH2,     fromMap16),
        OverObj(rock_sl,    1, 1, IDC_STOCK_ROCK_SL,   fromMap16),
        OverObj(rock_sh,    1, 1, IDC_STOCK_ROCK_SH,   fromMap16),
        OverObj(peg,        1, 1, IDC_STOCK_PEG,       fromMap16),
        OverObj(rock_bl,    2, 2, IDC_STOCK_ROCK_BL,   fromMap16),
        OverObj(rock_bh,    2, 2, IDC_STOCK_ROCK_BH,   fromMap16),
        OverObj(warp,       1, 1, IDC_STOCK_WARP,      fromMap16),
        OverObj(rockPile,   2, 2, IDC_STOCK_ROCKPILE,  fromMap16),
        OverObj(sign,       1, 1, IDC_STOCK_SIGN,      fromMap16),
        OverObj(grass,      1, 1, IDC_STOCK_GRASS,     fromMap16),
        OverObj(jumpPoint,  1, 1, IDC_STOCK_JUMPPOINT, fromMap16),
        OverObj(burrow,     2, 2, IDC_STOCK_BURROW,    fromMap16)
    };
    
#endif
