    
    #include <string>
    
    #include "inttypes.h"
    
    #include "buffer.h"

#ifndef CORE_H

    #define CORE_H
    
    bool     IsBankChange(uint32_t cpuAddr, uint32_t size);
    
    int      XBA(int value);
    
    uint32_t CpuToRomAddr(uint32_t addr);
    uint32_t RomToCpuAddr(uint32_t addr);
    
    uint32_t GetBank(uint32_t addr);
    
    Buffer*  DecompressStandard(Buffer *inputBuf,
                                uint32_t &source,
                                bool littleEndian = true);
    
// ================================================

namespace Memory
{
    using std::string;
    
// ================================================
    
    struct MetaData
    {
        string name;
        string comment;
    };
}

// ================================================

#endif
