
    #include "inttypes.h"
    
    #include "buffer.h"

#ifdef MAP16BUF_H

    #define MAP16BUF_H

    class Map16Buf
    {
    
    public:
        
        uint8_t width;
        uint8_t height;
        
        bufPtr data;
        
    // ================================================
    
    public:
        
        Map16Buf(uint8_t width, uint8_t height)
        {
            this->width  = width;
            this->height = height;
            
            data = new Buffer(width, height, 2);
        }
    
    // ================================================
    
        ~Map16Buf()
        {
            delete data;
        }
    
    // ================================================
    
        // Copy constructor
        
        Map16Buf* operator = (Map16Buf *m)
        {
            if(this != m)
            {
                this->width = m->width;
                this->height = m->height;
                
                Buffer::Copy(data, m->data, 0, 0, m->data->length);
            }
            
            return this;
        }
    
    // ================================================
    
        uint16_t GetTile(uint16_t x, uint16_t y)
        {
            return data->Get2Bytes(x, y);
        }
    
    // ================================================
    
        static uint16_t GetX(uint16_t addr)
        {
            return (addr & 0x007E) << 3;
        }
        
        static uint16_t GetY(uint16_t addr)
        {
            return (addr & 0x1F80) >> 3;
        }
    
    // ================================================
    
        void SetTile(uint16_t addr, uint16_t value)
        {
            uint8_t x = GetX(addr) >> 4;
            uint8_t y = GetY(addr) >> 4;
            
            // ----------------------------
            
            if(addr > 0x2000)
                throw "Bad Map16 exception";
            
            SetTile(x, y, value);
        }
    
    // ================================================
    
        void SetTile(uint16_t x, uint16_t y, uint16_t value)
        {
            data->Put2Bytes(x, y, value);
        }
    };

#endif