
    #include <deque>
    
    #include "inttypes.h"
    
	/// #include "globals.h"
    #include "buffer.h"
	#include "core.h"
	
    #include "compresch_lttp.h"

#ifndef OVERDATA_H

    #define OVERDATA_H
    
namespace Overworld
{
    extern const uint32_t mask16;
    extern const uint32_t mask32;

// ================================================

    class OverData
    {
        static Map16Val const reservedMap16[];
        
    public:
        
        // passed in from the ZeldaGame structure
        bufPtr rom;
        
    public:
        
        // member functions
            
                OverData(bufPtr rom = NULL); ///, ExpandInfo *header = NULL);
                ~OverData();
                
        void    DecMapCounts(uint16_t mapVal);
        void    IncMapCounts(uint16_t mapVal, uint16_t *map2x2 = NULL);
        
        void    LoadOverlaysOld();
        
        void    LoadMapFlags();
        
        bool    LoadAllSpriteData();
        bool    LoadAllItemData();
        
        uint32_t FindMap16(uint16_t map8Vals[4]);
        uint32_t Map16To8(uint16_t map16Val, uint16_t map8Vals[4]);
        uint32_t Map32To16(uint16_t map32Val, uint16_t map16Vals[4]);
        uint32_t AllocateMap16(uint16_t map8Vals[4], uint16_t oldMap16, uint16_t threshold = 0);
        
        bufPtr  LoadMap8();
        bufPtr  LoadMap16(uint32_t index, map16Pos p);
    };
}
    
#endif