
    #include <iostream>

    using std::cout;
    using std::endl;

    //The template class definition for smart pointer
    template<class T>
    class smart_ptr 
    {
        
    protected:
        
        T *ptr;
        
    public:
        
        explicit smart_ptr(T *pVal = 0) throw()
        {
            if(pVal)
                ptr = pVal;
            else
                ptr = NULL;
        }
        
        //copy ctor
        smart_ptr(const smart_ptr<T>& ptrCopy) throw()
        {
            if(ptrCopy)
                ptr = ptrCopy;
            else
                ptr = 0;
        }
        
        smart_ptr<T>& operator= (smart_ptr<T>& ptrCopy) throw()
        {
            if(ptrCopy)
                ptr = &ptrCopy;
            else
                ptr = 0;
            
            return ptr;
        }
        
        //dtor
        ~smart_ptr()
        {
            if(ptr)
            {
                delete ptr;
            }
        }
        
        //overloading * operator
        T& operator*() const throw()
        {
            return *ptr;
        }
        
        //overloading -> operator
        T *operator->() const throw()
        {
            return ptr;
        }
        
        //function to get the pointer to the class
        T *get() const throw()
        {
            return ptr;
        }
    };

class MyClass
{
public:
    //ctor

    MyClass()
    {
        str=new char[255];
        cout << "Memory allocated"<<endl;
    }
    //dtor

    ~MyClass()
    {
        delete[] str;
        cout <<"Memory deallocated"<<endl;
    }
    //Function to display the string

    void display()
    {
        strcpy(str,"This is a test string");
        cout<<str<<endl;
    }
private:
    char* str;
};
