#include "dungtypes.h"

namespace Thorn
{
    map<string, IndirectBlock> defaultBlocks
    {
        { "obj_floor0",  IndirectBlock(0x0000, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor1",  IndirectBlock(0x0010, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor2",  IndirectBlock(0x0020, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor3",  IndirectBlock(0x0030, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor4",  IndirectBlock(0x0040, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor5",  IndirectBlock(0x0050, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor6",  IndirectBlock(0x0060, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor7",  IndirectBlock(0x0070, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor8",  IndirectBlock(0x0080, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor9",  IndirectBlock(0x0090, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor10", IndirectBlock(0x00a0, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor11", IndirectBlock(0x00b0, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor12", IndirectBlock(0x00c0, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor13", IndirectBlock(0x00d0, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor14", IndirectBlock(0x00e0, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_floor15", IndirectBlock(0x00f0, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        
        { "obj_1_00", IndirectBlock(0x03d8, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_01", IndirectBlock(0x02e8, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_02", IndirectBlock(0x02f8, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_03", IndirectBlock(0x0328, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_04", IndirectBlock(0x0338, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_05", IndirectBlock(0x0400, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_06", IndirectBlock(0x0410, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_07", IndirectBlock(0x0388, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_08", IndirectBlock(0x0390, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_09", IndirectBlock(0x0420, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_0a", IndirectBlock(0x042a, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_0b", IndirectBlock(0x0434, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_0c", IndirectBlock(0x043e, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_0d", IndirectBlock(0x0448, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_0e", IndirectBlock(0x0452, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_0f", IndirectBlock(0x045c, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_10", IndirectBlock(0x0466, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_11", IndirectBlock(0x0470, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_12", IndirectBlock(0x047a, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_13", IndirectBlock(0x0484, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_14", IndirectBlock(0x048e, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_15", IndirectBlock(0x0498, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_16", IndirectBlock(0x04a2, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_17", IndirectBlock(0x04ac, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_18", IndirectBlock(0x04b6, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_19", IndirectBlock(0x04c0, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_1a", IndirectBlock(0x04ca, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_1b", IndirectBlock(0x04d4, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_1c", IndirectBlock(0x04de, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_1d", IndirectBlock(0x04e8, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_1e", IndirectBlock(0x04f2, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_1f", IndirectBlock(0x04fc, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_20", IndirectBlock(0x0506, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_21_0", IndirectBlock(0x0598, 1, 3, { 0, 1, 2 }) },
        { "obj_1_21_1", IndirectBlock(0x059e, 1, 3, { 0, 1, 2 }) },
        { "obj_1_21_2", IndirectBlock(0x05a4, 1, 3, { 0, 1, 2 }) },
        { "obj_1_22_0", IndirectBlock(0x0600, 1, 1, { 0 }) },
        { "obj_1_22_1", IndirectBlock(0x0602, 1, 1, { 0 }) },
        { "obj_1_22_2", IndirectBlock(0x0604, 1, 1, { 0 }) },
        { "obj_1_23_0", IndirectBlock(0x063c, 1, 1, { 0 }) },
        { "obj_1_23_1", IndirectBlock(0x063e, 1, 1, { 0 }) },
        { "obj_1_23_2", IndirectBlock(0x0640, 1, 1, { 0 }) },
        { "obj_1_24_0", IndirectBlock(0x063c, 1, 1, { 0 }) },
        { "obj_1_24_1", IndirectBlock(0x063e, 1, 1, { 0 }) },
        { "obj_1_24_2", IndirectBlock(0x0640, 1, 1, { 0 }) },
        { "obj_1_25_0", IndirectBlock(0x063c, 1, 1, { 0 }) },
        { "obj_1_25_1", IndirectBlock(0x063e, 1, 1, { 0 }) },
        { "obj_1_25_2", IndirectBlock(0x0640, 1, 1, { 0 }) },
        { "obj_1_26_0", IndirectBlock(0x063c, 1, 1, { 0 }) },
        { "obj_1_26_1", IndirectBlock(0x063e, 1, 1, { 0 }) },
        { "obj_1_26_2", IndirectBlock(0x0640, 1, 1, { 0 }) },
        { "obj_1_27_0", IndirectBlock(0x063c, 1, 1, { 0 }) },
        { "obj_1_27_1", IndirectBlock(0x063e, 1, 1, { 0 }) },
        { "obj_1_27_2", IndirectBlock(0x0640, 1, 1, { 0 }) },
        { "obj_1_28_0", IndirectBlock(0x0642, 1, 1, { 0 }) },
        { "obj_1_28_1", IndirectBlock(0x0644, 1, 1, { 0 }) },
        { "obj_1_28_2", IndirectBlock(0x0646, 1, 1, { 0 }) },
        { "obj_1_29_0", IndirectBlock(0x064c, 1, 1, { 0 }) },
        { "obj_1_29_1", IndirectBlock(0x064e, 1, 1, { 0 }) },
        { "obj_1_29_2", IndirectBlock(0x0650, 1, 1, { 0 }) },
        { "obj_1_2a_0", IndirectBlock(0x0652, 1, 1, { 0 }) },
        { "obj_1_2a_1", IndirectBlock(0x0654, 1, 1, { 0 }) },
        { "obj_1_2a_2", IndirectBlock(0x0656, 1, 1, { 0 }) },
        { "obj_1_2b_0", IndirectBlock(0x0658, 1, 1, { 0 }) },
        { "obj_1_2b_1", IndirectBlock(0x065a, 1, 1, { 0 }) },
        { "obj_1_2b_2", IndirectBlock(0x065c, 1, 1, { 0 }) },
        { "obj_1_2c_0", IndirectBlock(0x065e, 1, 1, { 0 }) },
        { "obj_1_2c_1", IndirectBlock(0x0660, 1, 1, { 0 }) },
        { "obj_1_2c_2", IndirectBlock(0x0662, 1, 1, { 0 }) },
        { "obj_1_2d_0", IndirectBlock(0x0664, 1, 1, { 0 }) },
        { "obj_1_2d_1", IndirectBlock(0x0666, 1, 1, { 0 }) },
        { "obj_1_2d_2", IndirectBlock(0x0668, 1, 1, { 0 }) },
        { "obj_1_2e_0", IndirectBlock(0x066a, 1, 1, { 0 }) },
        { "obj_1_2e_1", IndirectBlock(0x066c, 1, 1, { 0 }) },
        { "obj_1_2e_2", IndirectBlock(0x066e, 1, 1, { 0 }) },
        { "obj_1_2f_0", IndirectBlock(0x0688, 2, 2, { 1, 0, 2, 0 }) },
        { "obj_1_2f_1", IndirectBlock(0x0688, 1, 2, { 3, 0 }) },
        { "obj_1_2f_2", IndirectBlock(0x0688, 2, 2, { 4, 0, 5, 0 }) },
        { "obj_1_30_0", IndirectBlock(0x0694, 2, 2, { 0, 1, 0, 2 }) },
        { "obj_1_30_1", IndirectBlock(0x0694, 1, 2, { 0, 3 }) },
        { "obj_1_30_2", IndirectBlock(0x0694, 2, 2, { 0, 4, 0, 6 }) },
        { "obj_1_33", IndirectBlock(0x06a8, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_1_34", IndirectBlock(0x06c8, 1, 1, { 0 }) },
        { "obj_1_36", IndirectBlock(0x078a, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_1_37", IndirectBlock(0x07aa, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_1_38", IndirectBlock(0x0e26, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_39", IndirectBlock(0x084a, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_3a", IndirectBlock(0x086a, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_1_3b", IndirectBlock(0x0882, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_1_3c_0", IndirectBlock(0x08ca, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_3c_1", IndirectBlock(0x08d2, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_3d", IndirectBlock(0x185a, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_3e", IndirectBlock(0x08fa, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_3f_0", IndirectBlock(0x091a, 1, 1, { 0 }) },
        { "obj_1_3f_1", IndirectBlock(0x091c, 1, 1, { 0 }) },
        { "obj_1_3f_2", IndirectBlock(0x091e, 1, 1, { 0 }) },
        { "obj_1_40_0", IndirectBlock(0x0920, 1, 1, { 0 }) },
        { "obj_1_40_1", IndirectBlock(0x0922, 1, 1, { 0 }) },
        { "obj_1_40_2", IndirectBlock(0x0924, 1, 1, { 0 }) },
        { "obj_1_41_0", IndirectBlock(0x092a, 1, 1, { 0 }) },
        { "obj_1_41_1", IndirectBlock(0x092c, 1, 1, { 0 }) },
        { "obj_1_41_2", IndirectBlock(0x092e, 1, 1, { 0 }) },
        { "obj_1_42_0", IndirectBlock(0x0930, 1, 1, { 0 }) },
        { "obj_1_42_1", IndirectBlock(0x0932, 1, 1, { 0 }) },
        { "obj_1_42_2", IndirectBlock(0x0934, 1, 1, { 0 }) },
        { "obj_1_43_0", IndirectBlock(0x0936, 1, 1, { 0 }) },
        { "obj_1_43_1", IndirectBlock(0x0938, 1, 1, { 0 }) },
        { "obj_1_43_2", IndirectBlock(0x093a, 1, 1, { 0 }) },
        { "obj_1_44_0", IndirectBlock(0x093c, 1, 1, { 0 }) },
        { "obj_1_44_1", IndirectBlock(0x093e, 1, 1, { 0 }) },
        { "obj_1_44_2", IndirectBlock(0x0940, 1, 1, { 0 }) },
        { "obj_1_45_0", IndirectBlock(0x0942, 1, 1, { 0 }) },
        { "obj_1_45_1", IndirectBlock(0x0944, 1, 1, { 0 }) },
        { "obj_1_45_2", IndirectBlock(0x0946, 1, 1, { 0 }) },
        { "obj_1_46_0", IndirectBlock(0x0948, 1, 1, { 0 }) },
        { "obj_1_46_1", IndirectBlock(0x094a, 1, 1, { 0 }) },
        { "obj_1_46_2", IndirectBlock(0x094c, 1, 1, { 0 }) },
        { "obj_1_47_0", IndirectBlock(0x094e, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_47_1", IndirectBlock(0x0958, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_47_2", IndirectBlock(0x0962, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_1_48_0", IndirectBlock(0x096c, 1, 3, { 0, 1, 2 }) },
        { "obj_1_48_1", IndirectBlock(0x0972, 1, 3, { 0, 1, 2 }) },
        { "obj_1_48_2", IndirectBlock(0x0978, 1, 3, { 0, 1, 2 }) },
        { "obj_1_49", IndirectBlock(0x097e, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_4a", IndirectBlock(0x098e, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_4b", IndirectBlock(0x0902, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_4c_0", IndirectBlock(0x099e, 1, 3, { 0, 1, 2 }) },
        { "obj_1_4c_1", IndirectBlock(0x09a4, 1, 3, { 0, 1, 2 }) },
        { "obj_1_4c_2", IndirectBlock(0x09aa, 1, 3, { 0, 1, 2 }) },
        { "obj_1_4d_0", IndirectBlock(0x09d8, 1, 4, { 0, 1, 2, 3 }) },
        { "obj_1_4d_1", IndirectBlock(0x09e0, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_4d_2", IndirectBlock(0x09f0, 1, 4, { 0, 1, 2, 3 }) },
        { "obj_1_4e_0", IndirectBlock(0x09d8, 1, 4, { 0, 1, 2, 3 }) },
        { "obj_1_4e_1", IndirectBlock(0x09e0, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_4e_2", IndirectBlock(0x09f0, 1, 4, { 0, 1, 2, 3 }) },
        { "obj_1_4f_0", IndirectBlock(0x09d8, 1, 4, { 0, 1, 2, 3 }) },
        { "obj_1_4f_1", IndirectBlock(0x09e0, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_4f_2", IndirectBlock(0x09f0, 1, 4, { 0, 1, 2, 3 }) },
        { "obj_1_50", IndirectBlock(0x09fa, 1, 1, { 0 }) },
        { "obj_1_51_0", IndirectBlock(0x156c, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_51_1", IndirectBlock(0x1578, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_51_2", IndirectBlock(0x1584, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_52_0", IndirectBlock(0x1590, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_52_1", IndirectBlock(0x159c, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_52_2", IndirectBlock(0x15a8, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_53", IndirectBlock(0x1d86, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_55", IndirectBlock(0x0a14, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_56", IndirectBlock(0x0a24, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_5b_0", IndirectBlock(0x14dc, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_5b_1", IndirectBlock(0x14e8, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_5b_2", IndirectBlock(0x14f4, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_5c_0", IndirectBlock(0x1500, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_5c_1", IndirectBlock(0x150c, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_5c_2", IndirectBlock(0x1518, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_5d_0", IndirectBlock(0x061e, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_5d_1", IndirectBlock(0x062a, 1, 3, { 0, 1, 2 }) },
        { "obj_1_5d_2", IndirectBlock(0x0630, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_5e", IndirectBlock(0x0e52, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_5f_0", IndirectBlock(0x03d8, 1, 1, { 0 }) },
        { "obj_1_5f_1", IndirectBlock(0x03da, 1, 1, { 0 }) },
        { "obj_1_5f_2", IndirectBlock(0x03dc, 1, 1, { 0 }) },
        { "obj_1_60", IndirectBlock(0x03d8, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_61", IndirectBlock(0x02c8, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_62", IndirectBlock(0x02d8, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_63", IndirectBlock(0x0308, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_64", IndirectBlock(0x0318, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_65", IndirectBlock(0x03e0, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_66", IndirectBlock(0x03f0, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_67", IndirectBlock(0x0378, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_68", IndirectBlock(0x0380, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_69_0", IndirectBlock(0x05fa, 1, 1, { 0 }) },
        { "obj_1_69_1", IndirectBlock(0x05fc, 1, 1, { 0 }) },
        { "obj_1_69_2", IndirectBlock(0x05fe, 1, 1, { 0 }) },
        { "obj_1_6a", IndirectBlock(0x0648, 1, 1, { 0 }) },
        { "obj_1_6b", IndirectBlock(0x064a, 1, 1, { 0 }) },
        { "obj_1_6c_0", IndirectBlock(0x0670, 2, 2, { 1, 2, 0, 0 }) },
        { "obj_1_6c_1", IndirectBlock(0x0670, 2, 1, { 3, 0 }) },
        { "obj_1_6c_2", IndirectBlock(0x0670, 2, 2, { 4, 5, 0, 0 }) },
        { "obj_1_6d_0", IndirectBlock(0x067c, 2, 2, { 0, 0, 1, 2 }) },
        { "obj_1_6d_1", IndirectBlock(0x067c, 2, 1, { 0, 3 }) },
        { "obj_1_6d_2", IndirectBlock(0x067c, 2, 2, { 0, 0, 4, 5 }) },
        { "obj_1_70", IndirectBlock(0x06a8, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_1_71", IndirectBlock(0x06c8, 1, 1, { 0 }) },
        { "obj_1_73", IndirectBlock(0x07aa, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_1_74", IndirectBlock(0x07ca, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_1_75", IndirectBlock(0x084a, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_76", IndirectBlock(0x089a, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_77", IndirectBlock(0x08b2, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_78", IndirectBlock(0x090a, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_79", IndirectBlock(0x0926, 1, 1, { 0 }) },
        { "obj_1_7a", IndirectBlock(0x0928, 1, 1, { 0 }) },
        { "obj_1_7b", IndirectBlock(0x0912, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_7c", IndirectBlock(0x09f8, 1, 1, { 0 }) },
        { "obj_1_7d", IndirectBlock(0x1d7e, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_7f", IndirectBlock(0x0a34, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_80", IndirectBlock(0x0a44, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_81", IndirectBlock(0x0a54, 3, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_1_82", IndirectBlock(0x0a6c, 3, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_1_83", IndirectBlock(0x0a84, 3, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_1_84", IndirectBlock(0x0a9c, 3, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_1_85_0", IndirectBlock(0x1524, 3, 2, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_85_1", IndirectBlock(0x1530, 3, 2, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_85_2", IndirectBlock(0x153c, 3, 2, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_86_0", IndirectBlock(0x1548, 3, 2, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_86_1", IndirectBlock(0x1554, 3, 2, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_86_2", IndirectBlock(0x1560, 3, 2, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_87", IndirectBlock(0x085a, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_88_0", IndirectBlock(0x0606, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_88_1", IndirectBlock(0x0606, 2, 1, { 4, 5 }) },
        { "obj_1_88_2", IndirectBlock(0x0606, 2, 3, { 6, 7, 8, 9, 10, 11 }) },
        { "obj_1_89", IndirectBlock(0x0e52, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_8a_0", IndirectBlock(0x05fa, 1, 1, { 0 }) },
        { "obj_1_8a_1", IndirectBlock(0x05fa, 1, 1, { 1 }) },
        { "obj_1_8a_2", IndirectBlock(0x05fa, 1, 1, { 2 }) },
        { "obj_1_8b", IndirectBlock(0x06a0, 1, 1, { 0 }) },
        { "obj_1_8c", IndirectBlock(0x06a2, 1, 1, { 0 }) },
        { "obj_1_8d", IndirectBlock(0x0b12, 1, 1, { 0 }) },
        { "obj_1_8e", IndirectBlock(0x0b14, 1, 1, { 0 }) },
        { "obj_1_8f_0", IndirectBlock(0x09b0, 2, 1, { 0, 1 }) },
        { "obj_1_8f_1", IndirectBlock(0x09b1, 2, 1, { 2, 3 }) },
        { "obj_1_90", IndirectBlock(0x0b46, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_91", IndirectBlock(0x0b56, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_92", IndirectBlock(0x1f52, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_93", IndirectBlock(0x1f5a, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_94", IndirectBlock(0x0288, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_1_a0", IndirectBlock(0x03d8, 1, 1, { 0 }) },
        { "obj_1_a1", IndirectBlock(0x03d8, 1, 1, { 0 }) },
        { "obj_1_a2", IndirectBlock(0x03d8, 1, 1, { 0 }) },
        { "obj_1_a3", IndirectBlock(0x03d8, 1, 1, { 0 }) },
        { "obj_1_a4_0", IndirectBlock(0x063c, 1, 1, { 0 }) },
        { "obj_1_a4_1", IndirectBlock(0x0648, 1, 1, { 0 }) },
        { "obj_1_a4_2", IndirectBlock(0x0642, 1, 1, { 0 }) },
        { "obj_1_a4_3", IndirectBlock(0x063e, 1, 1, { 0 }) },
        { "obj_1_a4_4", IndirectBlock(0x05aa, 1, 1, { 0 }) },
        { "obj_1_a4_5", IndirectBlock(0x0644, 1, 1, { 0 }) },
        { "obj_1_a4_6", IndirectBlock(0x0640, 1, 1, { 0 }) },
        { "obj_1_a4_7", IndirectBlock(0x064a, 1, 1, { 0 }) },
        { "obj_1_a4_8", IndirectBlock(0x0646, 1, 1, { 0 }) },
        { "obj_1_a5", IndirectBlock(0x05b2, 1, 1, { 0 }) },
        { "obj_1_a6", IndirectBlock(0x05b2, 1, 1, { 0 }) },
        { "obj_1_a7", IndirectBlock(0x05b2, 1, 1, { 0 }) },
        { "obj_1_a8", IndirectBlock(0x05b2, 1, 1, { 0 }) },
        { "obj_1_a9", IndirectBlock(0x00e0, 1, 1, { 0 }) },
        { "obj_1_aa", IndirectBlock(0x00e0, 1, 1, { 0 }) },
        { "obj_1_ab", IndirectBlock(0x00e0, 1, 1, { 0 }) },
        { "obj_1_ac", IndirectBlock(0x00e0, 1, 1, { 0 }) },
        { "obj_1_b0", IndirectBlock(0x06a4, 1, 1, { 0 }) },
        { "obj_1_b1", IndirectBlock(0x06a6, 1, 1, { 0 }) },
        { "obj_1_b2", IndirectBlock(0x0ae6, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_1_b3_0", IndirectBlock(0x0b06, 1, 1, { 0 }) },
        { "obj_1_b3_1", IndirectBlock(0x0b08, 1, 1, { 0 }) },
        { "obj_1_b3_2", IndirectBlock(0x0b0a, 1, 1, { 0 }) },
        { "obj_1_b4_0", IndirectBlock(0x0b0c, 1, 1, { 0 }) },
        { "obj_1_b4_1", IndirectBlock(0x0b0e, 1, 1, { 0 }) },
        { "obj_1_b4_2", IndirectBlock(0x0b10, 1, 1, { 0 }) },
        { "obj_1_b5", IndirectBlock(0x0b16, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_b6", IndirectBlock(0x0b26, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_b7", IndirectBlock(0x0b36, 2, 4, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_1_b8", IndirectBlock(0x1f52, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_b9", IndirectBlock(0x1f5a, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_ba", IndirectBlock(0x0288, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_1_bb", IndirectBlock(0x0eba, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_c0", IndirectBlock(0x03d8, 1, 1, { 0 }) },
        { "obj_1_c1_0", IndirectBlock(0x0510, 3, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8 }) },
        { "obj_1_c1_1", IndirectBlock(0x0522, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_c1_2", IndirectBlock(0x052e, 3, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8 }) },
        { "obj_1_c1_3", IndirectBlock(0x0540, 3, 2, { 0, 3, 1, 4, 2, 5 }) },
        { "obj_1_c1_4", IndirectBlock(0x054c, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_c1_5", IndirectBlock(0x0554, 3, 2, { 0, 3, 1, 4, 2, 5 }) },
        { "obj_1_c1_6", IndirectBlock(0x0560, 3, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8 }) },
        { "obj_1_c1_7", IndirectBlock(0x0572, 2, 3, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_1_c1_8", IndirectBlock(0x057e, 3, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8 }) },
        { "obj_1_c1_9", IndirectBlock(0x0590, 3, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8 }) },
        { "obj_1_c2", IndirectBlock(0x05aa, 1, 1, { 0 }) },
        { "obj_1_c3", IndirectBlock(0x05aa, 1, 1, { 0 }) },
        { "obj_1_c4", IndirectBlock(0x0000, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_c5", IndirectBlock(0x0168, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_c6", IndirectBlock(0x00e0, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_c7", IndirectBlock(0x0158, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_c8", IndirectBlock(0x0100, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_c9", IndirectBlock(0x0110, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_ca", IndirectBlock(0x0178, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_d1", IndirectBlock(0x0130, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_d2", IndirectBlock(0x0148, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_d7", IndirectBlock(0x00e0, 1, 1, { 0 }) },
        { "obj_1_d9", IndirectBlock(0x00f0, 2, 4, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_db", IndirectBlock(0x0000, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_dc_0", IndirectBlock(0x0ab4, 1, 1, { 0 }) },
        { "obj_1_dc_1", IndirectBlock(0x0ab4, 1, 1, { 3 }) },
        { "obj_1_dc_10", IndirectBlock(0x0ab4, 1, 2, { 10, 11 }) },
        { "obj_1_dc_11", IndirectBlock(0x0ab4, 1, 2, { 13, 14 }) },
        { "obj_1_dc_12", IndirectBlock(0x0ab4, 1, 2, { 16, 17 }) },
        { "obj_1_dc_13", IndirectBlock(0x0ab4, 1, 2, { 19, 20 }) },
        { "obj_1_dc_2", IndirectBlock(0x0ab4, 1, 1, { 6 }) },
        { "obj_1_dc_3", IndirectBlock(0x0ab4, 1, 1, { 9 }) },
        { "obj_1_dc_4", IndirectBlock(0x0ab4, 1, 1, { 12 }) },
        { "obj_1_dc_5", IndirectBlock(0x0ab4, 1, 1, { 15 }) },
        { "obj_1_dc_6", IndirectBlock(0x0ab4, 1, 1, { 18 }) },
        { "obj_1_dc_7", IndirectBlock(0x0ab4, 1, 2, { 1, 2 }) },
        { "obj_1_dc_8", IndirectBlock(0x0ab4, 1, 2, { 4, 5 }) },
        { "obj_1_dc_9", IndirectBlock(0x0ab4, 1, 2, { 7, 8 }) },
        { "obj_1_dd_0", IndirectBlock(0x08da, 1, 1, { 0 }) },
        { "obj_1_dd_1", IndirectBlock(0x08da, 1, 1, { 4 }) },
        { "obj_1_dd_2", IndirectBlock(0x08da, 1, 2, { 8, 12 }) },
        { "obj_1_dd_3", IndirectBlock(0x08da, 2, 1, { 1, 2 }) },
        { "obj_1_dd_4", IndirectBlock(0x08da, 2, 1, { 5, 6 }) },
        { "obj_1_dd_5", IndirectBlock(0x08da, 1, 2, { 9, 13 }) },
        { "obj_1_dd_6", IndirectBlock(0x08da, 1, 1, { 3 }) },
        { "obj_1_dd_7", IndirectBlock(0x08da, 1, 1, { 7 }) },
        { "obj_1_dd_8", IndirectBlock(0x08da, 1, 2, { 11, 15 }) },
        { "obj_1_de", IndirectBlock(0x0ade, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_1_df", IndirectBlock(0x0188, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_e0", IndirectBlock(0x01a0, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_e1", IndirectBlock(0x01b0, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_e2", IndirectBlock(0x01c0, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_e3", IndirectBlock(0x01d0, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_e4", IndirectBlock(0x01e0, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_e5", IndirectBlock(0x01f0, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_e6", IndirectBlock(0x0200, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_e7", IndirectBlock(0x0120, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_1_e8", IndirectBlock(0x02a8, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 7 }) },
        { "obj_2_00", IndirectBlock(0x0b66, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_01", IndirectBlock(0x0b86, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_02", IndirectBlock(0x0ba6, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_03", IndirectBlock(0x0bc6, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_04", IndirectBlock(0x0c66, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_05", IndirectBlock(0x0c86, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_06", IndirectBlock(0x0ca6, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_07", IndirectBlock(0x0cc6, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_08", IndirectBlock(0x0be6, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_09", IndirectBlock(0x0c06, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_0a", IndirectBlock(0x0c26, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_0b", IndirectBlock(0x0c46, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_0c", IndirectBlock(0x0ce6, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_0d", IndirectBlock(0x0d06, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_0e", IndirectBlock(0x0d26, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_0f", IndirectBlock(0x0d46, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_10", IndirectBlock(0x0d66, 3, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_2_11", IndirectBlock(0x0d7e, 3, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_2_12", IndirectBlock(0x0d96, 3, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_2_13", IndirectBlock(0x0dae, 3, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_2_14", IndirectBlock(0x0dc6, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_2_15", IndirectBlock(0x0dde, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_2_16", IndirectBlock(0x0df6, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_2_17", IndirectBlock(0x0e0e, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_2_18", IndirectBlock(0x0398, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_2_19", IndirectBlock(0x03a0, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_2_1a", IndirectBlock(0x03a8, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_2_1b", IndirectBlock(0x03b0, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_2_1c", IndirectBlock(0x0e32, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_23", IndirectBlock(0x0ede, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_2_24", IndirectBlock(0x0f1e, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_25", IndirectBlock(0x0f3e, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_27", IndirectBlock(0x0f6a, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_2_29", IndirectBlock(0x0f72, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_2_2b", IndirectBlock(0x0fa2, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_2_34", IndirectBlock(0x0e52, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_2_3d", IndirectBlock(0x1488, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_2_3f", IndirectBlock(0x2086, 8, 7, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55 }) },
        { "obj_3_04", IndirectBlock(0x0a0c, 1, 1, { 0 }) },
        { "obj_3_05", IndirectBlock(0x09fc, 1, 1, { 0 }) },
        { "obj_3_06", IndirectBlock(0x09fe, 1, 1, { 0 }) },
        { "obj_3_07", IndirectBlock(0x0a00, 1, 1, { 0 }) },
        { "obj_3_08", IndirectBlock(0x0a02, 1, 1, { 0 }) },
        { "obj_3_09", IndirectBlock(0x0a04, 1, 1, { 0 }) },
        { "obj_3_0a", IndirectBlock(0x0a06, 1, 1, { 0 }) },
        { "obj_3_0b", IndirectBlock(0x0a08, 1, 1, { 0 }) },
        { "obj_3_0c", IndirectBlock(0x0a0a, 1, 1, { 0 }) },
        { "obj_3_0d_0", IndirectBlock(0x0000, 1, 1, { 0 }) },
        { "obj_3_0d_1", IndirectBlock(0x0000, 1, 1, { 1 }) },
        { "obj_3_0d_2", IndirectBlock(0x0000, 1, 3, { 2, 4, 5 }) },
        { "obj_3_0d_3", IndirectBlock(0x0000, 1, 1, { 3 }) },
        { "obj_3_0f", IndirectBlock(0x0a12, 1, 1, { 0 }) },
        { "obj_3_10", IndirectBlock(0x1dda, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_11", IndirectBlock(0x1de2, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_13", IndirectBlock(0x1dea, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_14", IndirectBlock(0x15fc, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_3_17_0", IndirectBlock(0x1488, 1, 1, { 0 }) },
        { "obj_3_17_1", IndirectBlock(0x1488, 1, 1, { 1 }) },
        { "obj_3_17_2", IndirectBlock(0x1488, 1, 3, { 2, 4, 5 }) },
        { "obj_3_17_3", IndirectBlock(0x1488, 1, 1, { 3 }) },
        { "obj_3_22", IndirectBlock(0x03b8, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_23", IndirectBlock(0x03c0, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_24", IndirectBlock(0x03c8, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_25", IndirectBlock(0x03d0, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_2d_0", IndirectBlock(0x0000, 1, 14, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13 }) },
        { "obj_3_2d_1", IndirectBlock(0x001c, 1, 14, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13 }) },
        { "obj_3_2d_2", IndirectBlock(0x0038, 4, 14, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55 }) },
        { "obj_3_2e_0", IndirectBlock(0x1bf2, 6, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23 }) },
        { "obj_3_2e_1", IndirectBlock(0x1c22, 1, 5, { 0, 1, 2, 3, 4 }) },
        { "obj_3_2e_2", IndirectBlock(0x1c2c, 4, 6, { 0, 4, 8, 12, 16, 20, 1, 5, 9, 13, 17, 21, 2, 6, 10, 14, 18, 22, 3, 7, 11, 15, 19, 23 }) },
        { "obj_3_2e_3", IndirectBlock(0x1c5c, 6, 2, { 0, 6, 1, 7, 2, 8, 3, 9, 4, 10, 5, 11 }) },
        { "obj_3_2e_4", IndirectBlock(0x1c74, 2, 6, { 0, 2, 4, 6, 8, 10, 1, 3, 5, 7, 9, 11 }) },
        { "obj_3_2e_5", IndirectBlock(0x1c8c, 5, 5, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24 }) },
        { "obj_3_34", IndirectBlock(0x1614, 3, 2, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_3_35", IndirectBlock(0x1614, 3, 2, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_3_36", IndirectBlock(0x1614, 6, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17 }) },
        { "obj_3_37", IndirectBlock(0x1614, 6, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17 }) },
        { "obj_3_38", IndirectBlock(0x1614, 3, 2, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_3_39", IndirectBlock(0x1614, 3, 2, { 0, 1, 2, 3, 4, 5 }) },
        { "obj_3_3a", IndirectBlock(0x1cbe, 4, 6, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23 }) },
        { "obj_3_3b", IndirectBlock(0x1cee, 4, 6, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23 }) },
        { "obj_3_3c", IndirectBlock(0x1d1e, 6, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23 }) },
        { "obj_3_3d", IndirectBlock(0x1d4e, 6, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23 }) },
        { "obj_3_3e", IndirectBlock(0x1d8e, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_3f", IndirectBlock(0x1d96, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_40", IndirectBlock(0x1d9e, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_41", IndirectBlock(0x1da6, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_42", IndirectBlock(0x1dae, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_43", IndirectBlock(0x1db6, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_44", IndirectBlock(0x1dbe, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_45", IndirectBlock(0x1dc6, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_46", IndirectBlock(0x1dce, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_48", IndirectBlock(0x0260, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_3_49", IndirectBlock(0x0280, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_4a", IndirectBlock(0x1f3a, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_4b", IndirectBlock(0x1f62, 8, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23 }) },
        { "obj_3_4c", IndirectBlock(0x1f92, 6, 8, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47 }) },
        { "obj_3_4d", IndirectBlock(0x1ff2, 6, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17 }) },
        { "obj_3_4e", IndirectBlock(0x2016, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_3_4f", IndirectBlock(0x1f42, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_50", IndirectBlock(0x0eaa, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_51", IndirectBlock(0x1f4a, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_52", IndirectBlock(0x1f52, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_53", IndirectBlock(0x1f5a, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_54_0", IndirectBlock(0x202e, 1, 1, { 0 }) },
        { "obj_3_54_1", IndirectBlock(0x2030, 1, 1, { 0 }) },
        { "obj_3_54_2", IndirectBlock(0x2032, 1, 3, { 0, 1, 2 }) },
        { "obj_3_54_3", IndirectBlock(0x2038, 1, 3, { 0, 1, 2 }) },
        { "obj_3_54_4", IndirectBlock(0x203e, 1, 1, { 0 }) },
        { "obj_3_54_5", IndirectBlock(0x2040, 1, 1, { 0 }) },
        { "obj_3_54_6", IndirectBlock(0x2042, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_3_55_0", IndirectBlock(0x2062, 3, 1, { 0, 1, 2 }) },
        { "obj_3_55_1", IndirectBlock(0x2068, 3, 1, { 0, 1, 2 }) },
        { "obj_3_55_2", IndirectBlock(0x206e, 3, 1, { 0, 1, 2 }) },
        { "obj_3_56", IndirectBlock(0x09b8, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_57", IndirectBlock(0x09c0, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_58", IndirectBlock(0x09c8, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_59", IndirectBlock(0x09d0, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_5a", IndirectBlock(0x0fa2, 4, 2, { 0, 4, 1, 5, 2, 6, 3, 8 }) },
        { "obj_3_5b_0", IndirectBlock(0x0fb2, 3, 1, { 0, 1, 2 }) },
        { "obj_3_5b_1", IndirectBlock(0x0fb8, 3, 1, { 0, 1, 2 }) },
        { "obj_3_5b_2", IndirectBlock(0x0fbe, 3, 1, { 0, 1, 2 }) },
        { "obj_3_5c", IndirectBlock(0x0fc4, 6, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23 }) },
        { "obj_3_5d", IndirectBlock(0x0ff4, 6, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17 }) },
        { "obj_3_5e", IndirectBlock(0x1018, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_5f", IndirectBlock(0x1020, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_60", IndirectBlock(0x15b4, 3, 6, { 0, 1, 2, 9, 10, 11, 3, 4, 5, 12, 13, 14, 6, 7, 8, 15, 16, 17 }) },
        { "obj_3_61", IndirectBlock(0x15d8, 3, 6, { 0, 1, 2, 9, 10, 11, 3, 4, 5, 12, 13, 14, 6, 7, 8, 15, 16, 17 }) },
        { "obj_3_62_0", IndirectBlock(0x20f6, 11, 11, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120 }) },
        { "obj_3_62_1", IndirectBlock(0x22da, 3, 2, { 0, 3, 1, 4, 2, 5 }) },
        { "obj_3_63", IndirectBlock(0x0eba, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_64", IndirectBlock(0x22e6, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_65", IndirectBlock(0x22ee, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_66", IndirectBlock(0x05da, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_3_67", IndirectBlock(0x281e, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_3_68", IndirectBlock(0x2ae0, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_3_69", IndirectBlock(0x2d2a, 3, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_3_6a", IndirectBlock(0x2f2a, 3, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_3_6b", IndirectBlock(0x22f6, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_3_6c", IndirectBlock(0x2316, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_3_6d", IndirectBlock(0x232e, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_3_6e", IndirectBlock(0x2346, 3, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_3_6f", IndirectBlock(0x235e, 3, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_3_70_0", IndirectBlock(0x2376, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_3_70_1", IndirectBlock(0x2396, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_3_73", IndirectBlock(0x00e0, 4, 2, { 0, 1, 2, 3, 4, 5, 6, 7 }) },
        { "obj_3_74_0", IndirectBlock(0x2436, 8, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31 }) },
        { "obj_3_74_1", IndirectBlock(0x2476, 8, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31 }) },
        { "obj_3_75", IndirectBlock(0x149c, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_76", IndirectBlock(0x24b6, 8, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23 }) },
        { "obj_3_77", IndirectBlock(0x24e6, 8, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23 }) },
        { "obj_3_78_0", IndirectBlock(0x2516, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_3_78_1", IndirectBlock(0x2536, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_3_79", IndirectBlock(0x1028, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_3_7a", IndirectBlock(0x1040, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_3_7b", IndirectBlock(0x1060, 4, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 }) },
        { "obj_3_7c", IndirectBlock(0x1070, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_7d", IndirectBlock(0x1078, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_3_7e", IndirectBlock(0x1080, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_bigChest", IndirectBlock(0x14ac, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_bigKeyLock", IndirectBlock(0x1494, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_telepath_tile", IndirectBlock(0x1dea, 2, 2, { 0, 1, 2, 4 }) },
        { "obj_blind_light_0", IndirectBlock(0x23b6, 8, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31 }) },
        { "obj_blind_light_1", IndirectBlock(0x23f6, 8, 4, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31 }) },
        { "obj_chest", IndirectBlock(0x149c, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_disabled_star_tile", IndirectBlock(0x0ea2, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_heavy_pot", IndirectBlock(0x0e5a, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_kholdstare_shell", IndirectBlock(0x1dfa, 10, 8, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79 }) },
        { "obj_litTorch", IndirectBlock(0x0eca, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_mole", IndirectBlock(0x1df2, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_openBigChest", IndirectBlock(0x14c4, 4, 3, { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }) },
        { "obj_openChest", IndirectBlock(0x14a4, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_other_pot", IndirectBlock(0x0e8a, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_pot", IndirectBlock(0x0e82, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_rupees", IndirectBlock(0x1dd6, 1, 2, { 0, 1 }) },
        { "obj_skull", IndirectBlock(0x0e92, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_star_tile", IndirectBlock(0x0e9a, 2, 2, { 0, 1, 2, 3 }) },
        { "obj_torch", IndirectBlock(0x0ec2, 2, 2, { 0, 1, 2, 3 }) },
        {
            "obj_trinexx_shell",
            IndirectBlock(0x1e9a,
                          10,
                          8,
                          {
                            0,  1,   2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12,
                            13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25,
                            26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38,
                            39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51,
                            52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64,
                            65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77,
                            78, 79
                          })
        }
    };
}
