
    #include "inttypes.h"
    
    #include <deque>
    #include <map>
    #include <algorithm>
    
    #include "graphics.h"
    #include "dungtypes.h"
    #include "overtypes.h"
    #include "map16buf.h"
    #include "texttypes.h"

#ifndef ZELDAFILE_H

    #define ZELDAFILE_H
    
    using std::deque;
    using std::map;
    using std::string;
    
    using Containers::Show;

    class ZeldaGame
    {
        
    public:
        
        Graphics::PaletteData palData;
        Graphics::PaletteThemes palThemes; 
        
        Graphics::TileData tileData;
        Graphics::TileThemes tileThemes;
        
        Dungeon::EntranceDeque startingPoints;
        Dungeon::EntranceDeque entrances;
        
        deque< Show<Dungeon::ObjectList> > m_layouts;
        
        Dungeon::RoomDeque dungRooms;
        
        Overworld::AreaDeque areas;
        
        //! \brief buffer containing data to convert map16 to map8 tiles.
        deque<Overworld::Map16Tile> map16To8;
        
        Text::MessageDeque m_messages;
        
        map<string, Show<Thorn::Block> > m_thornBlocks;
        
    public:
        
        ZeldaGame();
        ~ZeldaGame();
        
        void Test2DCompression();
        void TestCompresch();
        
    };
    
    typedef ZeldaGame* zgPtr;

#endif