/*
 *	Compresch - compression library
 *  Copyright 2008 Disch
 *  Copyright 2009 MathOnNapkins
 *  See license.txt for details
 */


#ifndef __COMPRESCH_KONAMIBLOCK_H__
#define __COMPRESCH_KONAMIBLOCK_H__

#include "compresch_types.h"

class Compresch_KonamiBlock
{
protected:
	static int			WorstCompressSize(int srclen);

	static int			CrunchAndOutput(BlockList& blocks, const uint8_t* src, int srclen, uint8_t* dst);

	static int			OutputRawBlock(const uint8_t* src, uint8_t* dst, int len);
	static int			OutputBlock(Block* blk, uint8_t* dst);

	
	static int			Decompress(const uint8_t* src, int srclen, uint8_t* dst, Block** blocks);
};

#endif