/*
 *	Compresch - compression library
 *  Copyright 2008 Disch
 *  See license.txt for details
 */


#if !defined SIZELIMITS_HEADER_GUARD

    #define SIZELIMITS_HEADER_GUARD
    
    class SIZELIMITS
    {
    public:
        
        // _________________________________________________________________
        SIZELIMITS(int p_block_size = 1,
                   int p_extra_byte = 32,
                   int p_len_max    = 1024)
          : m_block_size(p_block_size),
            m_extra_byte_after(p_extra_byte),
            m_len_max(p_len_max)
        {
            
        }
        
        /// size of the header for the block.
        int	m_block_size;
        
        /// length after which an extra byte is added to block header.
        int	m_extra_byte_after;
        
        /// maximum length of block.
        int	m_len_max;
    };

#endif