//Compile with:
//   g++ -O2 test.cpp -o test

#include <iostream>
#include <boost/function.hpp>

using std::cout;
using std::endl;
using boost::function;


//Use a typedef for our callback functions
class SimpleClass;
typedef   function<void (void)>   Callback;


class SimpleClass {
public:
  explicit SimpleClass(Callback on_delete) : on_delete(on_delete) {}
  ~SimpleClass() {
    //Inform anyone listening that we're about to be deleted.
    on_delete();
  }

private:
  Callback on_delete;
};



void print_out_pointer() {
  cout <<"  (callback reached)" <<endl;
}



int main(int argc, char *argv[])
{
  //First method:
  {
  Callback callback_function = Callback(&print_out_pointer);
  SimpleClass firstItem(callback_function);
  cout <<"Created: " <<&firstItem <<endl;
  }

  //Second method:
  {
  SimpleClass secondItem(Callback(&print_out_pointer));
  cout <<"Created: " <<&secondItem <<endl;
  }
}

