#include <boost/python.hpp>

#include "graphics.h"


//Helper: ref the uint32_t type
//TODO: Can't we do this without a helper?
uint32_t (Graphics::Color::*getColor_rgb)() = &Graphics::Color::operator uint32_t;


//Helper methods for get/set
//TODO: There's almost definitely a way to templatize this
Graphics::Palette<8>&  Group_8_16__get_item__(Graphics::Group<8,16>& group, int index) {
  if (index<0) { index = group.PaletteCount() + index; } //Negative indices are ok
  if (index>=group.PaletteCount()) { throw std::runtime_error("Group index entry out of range: get"); }
  return group[index];
}
void  Group_8_16__set_item__(Graphics::Group<8,16>& group, int index, Graphics::Palette<8>& value) {
  if (index<0) { index = group.PaletteCount() + index; } //Negative indices are ok
  if (index>=group.PaletteCount()) { throw std::runtime_error("Group index entry out of range: set"); }
  group[index] = value;
}

//Helper methods for get/set
Graphics::Palette<7>&  Group_7_5__get_item__(Graphics::Group<7,5>& group, int index) {
  if (index<0) { index = group.PaletteCount() + index; } //Negative indices are ok
  if (index>=group.PaletteCount()) { throw std::runtime_error("Group index entry out of range: get"); }
  return group[index];
}
void  Group_7_5__set_item__(Graphics::Group<7,5>& group, int index, Graphics::Palette<7>& value) {
  if (index<0) { index = group.PaletteCount() + index; } //Negative indices are ok
  if (index>=group.PaletteCount()) { throw std::runtime_error("Group index entry out of range: set"); }
  group[index] = value;
}

//Helper methods for get/set
Graphics::Palette<7>&  Group_7_3__get_item__(Graphics::Group<7,3>& group, int index) {
  if (index<0) { index = group.PaletteCount() + index; } //Negative indices are ok
  if (index>=group.PaletteCount()) { throw std::runtime_error("Group index entry out of range: get"); }
  return group[index];
}
void  Group_7_3__set_item__(Graphics::Group<7,3>& group, int index, Graphics::Palette<7>& value) {
  if (index<0) { index = group.PaletteCount() + index; } //Negative indices are ok
  if (index>=group.PaletteCount()) { throw std::runtime_error("Group index entry out of range: set"); }
  group[index] = value;
}

//Helper methods for get/set
Graphics::Palette<7>&  Group_7_1__get_item__(Graphics::Group<7,1>& group, int index) {
  if (index<0) { index = group.PaletteCount() + index; } //Negative indices are ok
  if (index>=group.PaletteCount()) { throw std::runtime_error("Group index entry out of range: get"); }
  return group[index];
}
void  Group_7_1__set_item__(Graphics::Group<7,1>& group, int index, Graphics::Palette<7>& value) {
  if (index<0) { index = group.PaletteCount() + index; } //Negative indices are ok
  if (index>=group.PaletteCount()) { throw std::runtime_error("Group index entry out of range: set"); }
  group[index] = value;
}

//Helper methods for get/set
Graphics::Color&  Palette_7__get_item__(Graphics::Palette<7>& pal, int index) {
  if (index<0) { index = pal.Length() + index; } //Negative indices are ok
  if (index>=pal.Length()) { throw std::runtime_error("Palette index entry out of range: get"); }
  return pal[index];
}
void  Palette_7__set_item__(Graphics::Palette<7>& pal, int index, Graphics::Color& value) {
  if (index<0) { index = pal.Length() + index; } //Negative indices are ok
  if (index>=pal.Length()) { throw std::runtime_error("Palette index entry out of range: set"); }
  pal[index] = value;
}

//Helper methods for get/set
Graphics::Color&  Palette_8__get_item__(Graphics::Palette<8>& pal, int index) {
  if (index<0) { index = pal.Length() + index; } //Negative indices are ok
  if (index>=pal.Length()) { throw std::runtime_error("Palette index entry out of range: get"); }
  return pal[index];
}
void  Palette_8__set_item__(Graphics::Palette<8>& pal, int index, Graphics::Color& value) {
  if (index<0) { index = pal.Length() + index; } //Negative indices are ok
  if (index>=pal.Length()) { throw std::runtime_error("Palette index entry out of range: set"); }
  pal[index] = value;
}

//Helper methods for get/set
Graphics::Tile<Graphics::Pixel3bpp>&  TileSet_Pixel3bpp_0x200__get_item__(Graphics::TileSet<Graphics::Pixel3bpp, 0x200>& ts, int index) {
  if (index<0) { index = ts.NumTiles() + index; } //Negative indices are ok
  if (index>=ts.NumTiles()) { throw std::runtime_error("TileSet index entry out of range: get"); }
  return ts(index);
}
void  TileSet_Pixel3bpp_0x200__set_item__(Graphics::TileSet<Graphics::Pixel3bpp, 0x200>& ts, int index, Graphics::Tile<Graphics::Pixel3bpp>& value) {
  if (index<0) { index = ts.NumTiles() + index; } //Negative indices are ok
  if (index>=ts.NumTiles()) { throw std::runtime_error("TileSet index entry out of range: set"); }
  ts(index) = value;
}


