#include <boost/python.hpp>

//NOTE: BlackMagic requires the following includes in overtypes.h. Putting them here for now
#include "graphics.h"

#include "overtypes.h"


//Helper: reference the correct version of getMapSlot
Containers::Slot<uint16_t>& (Overworld::Map16Buf::*getMapSlot_1)(uint8_t, uint8_t) = &Overworld::Map16Buf::operator();


//Helper methods for get/set
Overworld::Area&  AreaDeque__get_item__(std::deque<Overworld::Area>& group, int index) {
  if (index<0) { index = group.size() + index; } //Negative indices are ok
  if (index>=group.size()) { throw std::runtime_error("AreaDeque index entry out of range: get"); }
  return group[index];
}
void  AreaDeque__set_item__(std::deque<Overworld::Area>& group, int index, Overworld::Area& value) {
  if (index<0) { index = group.size() + index; } //Negative indices are ok
  if (index>=group.size()) { throw std::runtime_error("AreaDeque index entry out of range: set"); }
  group[index] = value;
}


//Get the sprites in a given phase (maybe better way to do this?)
std::list<Overworld::Sprite>& AreaSprByPhase(Overworld::Area& area, int index) {
  if (index<0 || index>2) { throw std::runtime_error("Error: only 3 allowed phases."); }
  return area.spr[index];
}


