#include <cmath>
#include <boost/python.hpp>

#include "texttypes.h"

using namespace boost::python;
using namespace Text;


//Export all relevant items in the Text namespace
void export_text()
{
  //EntityType enum
  enum_<EntityType>("TextEntityType")
    .value("Character", Character)
    .value("NextPic", NextPic)
    .value("Choose", Choose)
    .value("Item", Item)
    .value("Name", Name)
    .value("Window", Window)
    .value("Number", Number)
    .value("Position", Position)
    .value("ScrollSpd", ScrollSpd)
    .value("SelChng", SelChng)
    .value("Crash", Crash)
    .value("Choose2", Choose2)
    .value("Choose3", Choose3)
    .value("Scroll", Scroll)
    .value("Line1", Line1)
    .value("Line2", Line2)
    .value("Line3", Line3)
    .value("Color", Color)
    .value("Wait", Wait)
    .value("Sound", Sound)
    .value("Speed", Speed)
    .value("Command7b", Command7b)
    .value("Command7c", Command7c)
    .value("Command7d", Command7d)
    .value("WaitKey", WaitKey)
    .value("End", End)
  ;

  class_<Entity>("TextEntity")
    .add_property("type", &Entity::GetType)
    .add_property("param", &Entity::GetParam)
  ;

  class_<std::list<Entity> >("TextMessage")
    .def("size", &std::list<Entity>::size)
    .def("__iter__", iterator< std::list<Entity> >())  //Expose the iterators directly
  ;

  class_<std::deque<std::list<Entity> > >("TextMessageSet")
    .def("__iter__", iterator< std::deque<std::list<Entity> > >())  //Expose the iterators directly
  ;

}

