#
# Super simple cmake script:
#
# - Find JsonCpp
# This module finds the json-cpp parser.
#
# It sets the following variables:
#  JSONCPP_FOUND       - Set to false, or undefined, if JsonCpp isn't found.
#  JSONCPP_INCLUDE_DIR - The JsonCpp include directory.
#  JSONCPP_LIBRARY     - The JsonCpp library to link against.

FIND_PATH(JSONCPP_INCLUDE_DIR jsoncpp/json/json.h  jsoncpp/json.h)
FIND_LIBRARY(JSONCPP_LIBRARY NAMES jsoncpp)

IF (JSONCPP_INCLUDE_DIR AND JSONCPP_LIBRARY)
   SET(JSONCPP_FOUND TRUE)
ENDIF (JSONCPP_INCLUDE_DIR AND JSONCPP_LIBRARY)

IF (JSONCPP_FOUND)
   #Print
   IF (NOT JsonCpp_FIND_QUIETLY)
      MESSAGE(STATUS "Found JsonCpp: ${JSONCPP_LIBRARY}")
   ENDIF (NOT JsonCpp_FIND_QUIETLY)
ELSE (JSONCPP_FOUND)
   #Fatal?
   IF (JsonCpp_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "Could not find JsonCpp")
   ENDIF (JsonCpp_FIND_REQUIRED)
ENDIF (JSONCPP_FOUND)

