#pragma once

#include <QGraphicsView>

class FixedGridGraphicsScene;

class FixedGridGraphicsView : public QGraphicsView {
public:
    FixedGridGraphicsView(QWidget* parent=nullptr);


protected:
    //virtual bool event (QEvent* event);
    virtual void paintEvent (QPaintEvent* event);

    FixedGridGraphicsScene* fg_scene();

private:
    ///Step 1: Background. Complicated by the fact that we may not have to repaint ALL of it, and parts of it may be cached
    void performDrawing_Background(QPainter& painter, QRectF exposedSceneRect);

    ///Step 2: Items. May be painted indirectly. Determining which items to paint is one of the key speedups provided by this class.
    void performDrawing_Items(QPainter& painter, QRegion exposedRegion, QRectF exposedSceneRect, bool viewTransformed, const QTransform& viewTransform);

    //Step 3: Foreground. Very, very simple.
    void performDrawing_Foreground(QPainter& painter, QRectF exposedSceneRect);
};


