
    #include <iostream>
    #include <fstream>
    #include <string>
    #include <utility>
    #include <list>
    
    #include "zeldagame.h"

    using namespace std;
    
    using std::ofstream;
    
    string convChars[] =
    {
        // codes 0x00 and up
        "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M",
        "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z",
        
        "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m",
        "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z",
        
        "0", "1", "2", "3", "4", "5", "6", "7", "8", "9",
        
        // codes 0x3E and up
        "!", "?", "-", ".", ",", "[...]", ">", "(", ")",
        "[Anhk]", "[Waves]", "[Snake]", "[LinkL]", "[LinkR]",
        "\"", "[Up]", "[Down]", "[Left]", "[Right]", "'",
        
        // codes 52 and up
	    "[1HeartL]", "[1HeartR]", "[2HeartL]", "[3HeartL]",
        "[3HeartR]", "[4HeartL]", "[4HeartR]",
        
        " ", "<", "[A]", "[B]", "[X]", "[Y]",
        
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        
        // codes 0x67 and up
        "[NextPic]", "[Choose]", "[Item]", "[Name]", "[Window ",
        "[Number ", "[Position ", "[ScrollSpd ", "[SelChng]",
        
        // codes 0x70 and up
        "[Command 70]", "[Choose2]", "[Choose3]", "[Scroll]", 
        "[Line1]", "[Line2]", "[Line3]", "[Color ",
        "[Wait ", "[Sound ", "[Speed ",
        "[Command 7B]", "[Command 7C]", "[Command 7D]", "[WaitKey]", "[End]",
        
        // codes 0x80 and up
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        
        // codes 0x90 and up
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        
        // codes 0xA0 and up
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        
        // codes 0xB0 and up
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        
        // codes 0xC0 and up
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        
        // codes 0xD0 and up
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        
        // codes 0xE0 and up
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        
        // codes 0xF0 and up
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0",
        "\0", "\0", "\0", "\0", "\0", "\0", "\0", "\0"
    };
    
    void DumpScript(ZeldaGame &zg)
    {
        using namespace Text;
        
        MessageDeque ms = zg.m_messages;
        
        ofstream o("./dialogue.txt");
        
        // ------------------------------
        
        for
        (
            int i = 0;
            i < ms.size();
            ++i)
        {
            Message m = ms[i].Get();
            
            Message::iterator mit = m.begin();
            
            // ------------------------------------
            
            o << endl << endl << "[Msg " << i << "]";
            
            for
            (
                int j = 0; 
                j < m.size();
                ++j, ++mit)
            {
                EntityType et;
                Slot<uint8_t> param;
                
                Entity e = (*mit);
                
                // ------------------------------------
                
                et = e.GetType();
                
                param = e.GetParam();
                
                if(et == Character)
                {
                    uint8_t code = param;
                    
                    o << convChars[code];
                }
                else
                {
                    uint8_t code = (uint8_t) et;
                    
                    o << convChars[code];
                    
                    if( param.IsEmpty() == false )
                    {
                        int param_int = (*param);
                        
                        o << param_int << "]";
                    }
                    
                }
            }
        }
    }
    
    
